"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractUidFromJdbcUrl = exports.resolveJDBCDriver = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const installer_1 = require("./installer");
async function fileExistsOr(fsPath, fn) {
    if (fs_1.default.existsSync(fsPath)) {
        return fsPath;
    }
    return fn();
}
async function resolveJDBCDriver() {
    return fileExistsOr(path_1.default.join(process.cwd(), 'DatabricksJDBC42.jar'), async () => fileExistsOr(path_1.default.join(__dirname, '..', 'download', 'DatabricksJDBC42.jar'), async () => {
        const pathOrNull = await (0, installer_1.downloadJDBCDriver)();
        if (pathOrNull) {
            return pathOrNull;
        }
        throw new Error('Please download and place DatabricksJDBC42.jar inside your ' +
            'project directory');
    }));
}
exports.resolveJDBCDriver = resolveJDBCDriver;
function extractUidFromJdbcUrl(jdbcUrl) {
    const { pathname } = new URL(jdbcUrl);
    const [_, ...params] = pathname.split(';');
    const searchParams = new URLSearchParams(params.join('&'));
    return searchParams.get('UID') || 'token';
}
exports.extractUidFromJdbcUrl = extractUidFromJdbcUrl;
//# sourceMappingURL=helpers.js.map